
public class ListaDoblementeEnlazada {

	public static enum Direccion {HACIA_ADELANTE, HACIA_ATRAS}	
	
	private Nodo cabeza;
	private int numeroElementos; 
	
	class Nodo {

		private final int dato;
		private Nodo siguiente;
		private Nodo previo;

		public Nodo(int dato) {
			this.dato = dato;
		}

	}

	public Nodo insertarAlInicio(int dato) {

		Nodo nodo = new Nodo(dato);

		nodo.siguiente = cabeza;
		nodo.previo = null;

		if (null != cabeza) {

			cabeza.previo = nodo;

		}

		cabeza = nodo;
		
		numeroElementos++;
		
		return nodo;
		
	}

	public void imprimirLista() {
		
		imprimirLista(cabeza);
		
	}
	
	public void imprimirLista(Nodo nodo) {

		Nodo ultimo = null;
        //Recorrer hacia delante
		while (null != nodo) {

			System.out.print(nodo.dato + " ");
			ultimo = nodo;
			nodo = nodo.siguiente;

		}

		System.out.println();
        //Recorrer hacia atras
		while (null != ultimo) {

			System.out.print(ultimo.dato + " ");
			ultimo = ultimo.previo;

		}
		
	}

	public int[] recorrerLista(Direccion direccion) {
		
		return recorrerLista(cabeza, direccion);
		
	}
	
	public int[] recorrerLista(Nodo nodo, Direccion direccion) {
		
		if(0 == numeroElementos) {
			
			return null;
			
		}
		
		int[] datos = new int[numeroElementos];	
		int i = 0;
		
		Nodo ultimo = null;
		
		while (null != nodo) {
			
			datos[i++] = nodo.dato;
			ultimo = nodo;
			nodo = nodo.siguiente;

		}
		
		if(Direccion.HACIA_ATRAS.equals(direccion)) {
			
			i = 0;
			
			while (null != ultimo) {

                datos[i++] = ultimo.dato;  
				ultimo = ultimo.previo;

			}
		}
		
		return datos;
		
	}
	
}
